<template>
<div>


	<button style="margin-left:20%;" type="button" class="btn btn-primary" data-toggle="modal" data-target="#modalproducto">+ Agregar Productos</button>
 


<!-- Modal: AGREGAR CATEGORIAS -->
<div class="modal fade" id="modalproducto" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <!--Header-->
      <div class="modal-header">
        <h4 class="modal-title" id="myModalLabel">Producto</h4>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">×</span>
        </button>
      </div>
      <!--Body-->
     	 	<div class="modal-body">

     	 		<div class="row justify-content-center">
        <div class="col-md-8">
            <div class="headers">
                <div class="card-header">Registro Producto</div>

                <div class="formbody">
                    <form v-on:submit.prevent="create()" method="POST">
                       
                        <div class="form-group row">
                            <label for="nombre" class="col-md-4 col-form-label text-md-right">Nombre</label>

                            <div class="col-md-6">
                                <input v-model="producto.nombre" id="nombre" type="text" name="nombre"  required autocomplete="nombre" autofocus >                
                            </div>
                        </div>

                          <div class="form-group row">
                            <label for="descripcion" class="col-md-4 col-form-label text-md-right">Descripción</label>

                            <div class="col-md-6">
                                <input v-model="producto.descripcion" id="descripcion" type="text" name="descripcion" required autocomplete="descripcion">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="stock" class="col-md-4 col-form-label text-md-right">Stock</label>

                            <div class="col-md-6">
                                <input v-model="producto.stock" id="stock" type="number" name="stock" required autocomplete="stock">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="precio" class="col-md-4 col-form-label text-md-right">Precio</label>

                            <div class="col-md-6">
                                <input v-model="producto.precio" id="precio" type="number" name="precio" required autocomplete="precio">
                            </div>
                        </div>
                        
                        <div class="form-group row">
                            <label for="marca_id" class="col-md-4 col-form-label text-md-right">Marcas</label>

                           <select v-model="producto.marca_id" >
                               <option disabled value="">Seleccione una Marca...</option>
                             <option v-for="producto in marcas" v-bind:value="producto.id" name="marca_id">
                             {{producto.nombre}}
                           </option>
                           </select>
                        </div>

                        <div class="form-group row">
                            <label for="imagen" class="col-md-4 col-form-label text-md-right">Imagen</label>

                            <div class="col-md-6">
                                <input v-model="producto.imagen" id="imagen" type="text" name="imagen" required autocomplete="imagen">
                            </div>
                        </div>


                       <div class="form-group row">
                            <label for="categoria_id" class="col-md-4 col-form-label text-md-right">Categoria</label>

                           <select v-model="producto.categoria_id">

                            <option disabled value="">Seleccione una categoria...</option>

                             <option v-for="producto in categorias" v-bind:value="producto.id" name="categoria_id">
                             {{producto.nombre}}
                           </option>
                           </select>
                        </div>

                        
                       <button  type="submit"  class="btn btn-primary">Agregar</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

     		 </div>

		</div>
	</div>
</div>

<!--TERMINO REGIDTRO PRODUCTO MODAL-->

<!--EMPIEZO MODAL EDIT-->
<div class="modal fade" id="modaleditproductos" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <!--Header-->
      <div class="modal-header">
        <h4 class="modal-title" id="myModalLabel">Producto</h4>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">×</span>
        </button>
      </div>
      <!--Body-->
        <div class="modal-body">

          <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="headers">
                <div class="card-header">Editar Producto</div>

                <div class="formbody">
                    <form  method="POST">
                       
                        <div class="form-group row">
                            <label for="nombre" class="col-md-4 col-form-label text-md-right">Nombre</label>

                            <div class="col-md-6">
                                <input v-model="editar.nombre" id="nombre" type="text" name="nombre"  required autocomplete="nombre" autofocus pattern="[a-z]{1,15}">                
                            </div>
                        </div>

                          <div class="form-group row">
                            <label for="descripcion" class="col-md-4 col-form-label text-md-right">Descripción</label>

                            <div class="col-md-6">
                                <input v-model="editar.descripcion" id="descripcion" type="text" name="descripcion" required autocomplete="descripcion" pattern="[a-z]{1,15}">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="stock" class="col-md-4 col-form-label text-md-right">Stock</label>

                            <div class="col-md-6">
                                <input v-model="editar.stock" id="stock" type="number" name="stock" required autocomplete="stock">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="precio" class="col-md-4 col-form-label text-md-right">Precio</label>

                            <div class="col-md-6">
                                <input v-model="editar.precio" id="precio" type="number" name="precio" required autocomplete="precio">
                            </div>
                        </div>
                        
                       
                         <div class="form-group row">
                            <label for="marca_id" class="col-md-4 col-form-label text-md-right">Marcas</label>

                           <select v-model="editar.marca_id" >
                               <option disabled value="">Seleccione una categoria...</option>
                             <option v-for="producto in marcas" v-bind:value="producto.id" name="marca_id">
                             {{producto.nombre}}
                           </option>
                           </select>
                        </div>

                         <div class="form-group row">
                            <label for="imagen" class="col-md-4 col-form-label text-md-right">Imagen</label>

                            <div class="col-md-6">
                                <input v-model="editar.imagen" id="imagen" type="text" name="imagen" required autocomplete="imagen">
                            </div>
                        </div>


                           <div class="form-group row">
                            <label for="categoria_id" class="col-md-4 col-form-label text-md-right">Categoria</label>

                           <select v-model="editar.categoria_id" >

                            <option disabled value="">Seleccione una categoria...</option>

                             <option v-for="producto in categorias" v-bind:value="producto.id" name="categoria_id">
                             {{producto.nombre}}
                           </option>
                           </select>
                        </div>
                         <div class="form-group row">
                            <label for="codigo" class="col-md-4 col-form-label text-md-right">Codigo</label>

                            <div class="col-md-6">
                                <input v-model="editar.codigo" id="codigo" type="text" name="codigo" required autocomplete="codigo">
                          <br>  
                          <barcode  v-bind:value="editar.codigo">
            
                      </barcode>
                    </div>
                        </div>

                       <button  type="button" @click="updateprod(editar)" class="btn btn-primary">Editar</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

         </div>

    </div>
  </div>
</div>

 <form  id="form" class="form-inline my-2 my-lg-0">
                <input v-model="Search" style="width:55%;" id="control" class="form-control mr-sm-2" type="text" placeholder="Search by nombre">
                <button class="btn btn-outline-success my-2 my-sm-0" type=""><i class="fa fa-search" aria-hidden="true"></i></button>
            </form>
<div class="table-wrapper-scroll-y my-custom-scrollbar">
<table class="table table-bordered table-striped mb-0">
        <thead>
          <tr>
            <th>Nombre</th>
            <th>DESCRIPCION</th>
             <th>STOCK</th>
            <th>PRECIO</th>
             <th>MARCA</th>
            <th style="text-align:center">IMAGEN</th>
             <th>CATEGORIA</th>
             <th style="text-align:center">CODIGO</th>
              <th>EDITAR</th>
            <th>ELIMINAR</th>
          </tr>
        </thead>


		 

<tbody v-for="producto in searchproductos"  :key="producto.id">
          <tr>
            <td style="text-align:center;" >{{producto.nombre}}</td>
            <td style="text-align:center;">{{producto.descripcion}}</td>
            <td style="text-align:center;">{{producto.stock}}</td>
            <td style="text-align:center;">${{producto.precio}}</td>
            <td style="text-align:center;">{{producto.marca ? producto.marca.nombre : ''}}</td>
            <td style="text-align:center;"><img class="img" :src="producto.imagen" alt="producto.nombre" /></td>
            <td style="text-align:center;">{{producto.categoria ? producto.categoria.nombre : ''}}</td>
             <td style="text-align:center;"> <barcode  v-bind:value="producto.codigo">
            
                      </barcode></td>
           <td style="text-align:center"><button @click="editpro(producto)"  type="button" class="btn btn-primary" data-toggle="modal" data-target="#modaleditproductos">Editar</button>  
            </td>
            <td style="text-align:center"><button type="button" class="btn btn-danger" @click="remove(producto)">Eliminar</button></td>

          </tr>
        </tbody>

      </table>

      </div>

</div >
</template>

<script>
    export default {	
      
        computed:{
     searchproductos(){
    
     if(this.Search){
      let resultados = this.$parent.productos.filter(c => 
        c.nombre.toLowerCase().startsWith(this.Search));
       
      resultados =[
        ...resultados,
        ...this.$parent.productos.filter(c => c.marca.nombre.toLowerCase().startsWith(this.Search)),
        ...this.$parent.productos.filter(c => c.categoria.nombre.toLowerCase().startsWith(this.Search))
      ];
      return [...new Set(resultados)];
     }else{
        return this.$parent.productos;
      }
    },
      sum:function(){
       return this.producto.codigo=this.sam();
      }
  },
    	
		data() {
			return {
				csrf: document.head.querySelector('meta[name="csrf-token"]').getAttribute('content'),
    
				producto:{
					nombre:"",
					descripcion:"",
          stock:"",
          precio:"",
          marca_id:"",
          imagen:"",
          codigo:"",
          categoria_id:''
				},
        Search:"",
        categoria:{
          nombre:"",
          codigo:""
        },
          marca:{
            nombre:""
          },
          editar:{},
			}
		},
    props:["categorias","marcas","productos"],
		mounted(){
			this.fetchdata();
      this.marcasdata();
		},
		
		methods:{
			fetchdata(){
				const self = this;
				axios.get('api/productos').then(function(response){
					self.$parent.productos = response.data.map(function (prod) {
            return prod;

          });
					
				})
			},

      marcasdata(){
        const self = this;
        axios.get('api/marcas').then(function(response){
          self.$parent.marcas = response.data.map(function (mar) {
            return mar;

          });
          
        })
      },

      

		
			create(){
				axios.post("api/rproductos",this.producto).then(response=>{
          this.producto.nombre=""
          this.producto.descripcion=""
          this.producto.stock=""
          this.producto.precio=''
          this.producto.marca_id=""
          this.producto.imagen=""
          this.producto.categoria_id=''
          this.producto.codigo=""
          this.$parent.productos.push(response.data);
					console.log(response.data);
				})

        this.fetchdata();
			},

		remove(producto) {
                if (confirm("Esta seguro que desea eliminarlo?")) {
                    axios.delete('api/deleteprod/' + producto.id)
                }
                this.fetchdata();
            },

  editpro(producto){
              let uri ='api/editprod/'+ producto.id;
                axios.get(uri).then((response) => {
                    this.editar = response.data;
                });
            },

      
          updateprod(producto){
        let url ='api/updateprod/' + producto.id;
        axios.put(url,this.editar).then(resp=>{
          this.fetchdata();
          this.marcasdata();
          this.editar=resp.data;
          $('#modaleditproductos').modal('hide');
        })
       },

     
      sam(categoria){
        this.producto.codigo=this.categoria.codigo;
      }
      /*con(categoria,marca){
         for (var i = 0; i < this.producto.codigo; i++) {
     this.producto.codigo=concat(this.categoria.codigo + this.marca.codigo);
        }
     console.log(this.producto.codigo);
      }*/

     
			     
	
	}

}

</script>

<style scoped>

body {
  margin: 0;
  background: linear-gradient(45deg, #49a09d, #5f2c82);
  font-family: sans-serif;
  font-weight: 100;
}

.container {
  position: absolute;
  top: 5%;
  left: 5%;
  transform: translate(-50%, -50%);
}

table {
  width:100px;
  margin-left:60px;
  margin-top:2%;
  border-collapse: collapse;
  overflow: hidden;
  box-shadow: 0 0 20px rgba(0,0,0,0.1);
   border-top:2px solid #ccc;
  border-left: 2px solid #ccc;
  margin-bottom:1em;
}
.my-custom-scrollbar {
  height: 870px;
overflow-x:hidden;
overflow: auto;
}
.table-wrapper-scroll-y {
display: block;
}

th,
td {
  background-color: rgba(255,255,255,0.2);
  color: #000000;
  padding: 0.5em -1em;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;

}

th {
    padding: 0.5em 1em;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;
    white-space: pre;
   background-color: rgba(255,255,255,0.2);
  color: #000000;
}

thead {
  th {
    background-color: rgba(255,255,255,0.2);
  color: #000000;
  }
}

tbody {
  tr {
    &:hover {
      background-color: rgba(255,255,255,0.3);
    }
  }
  td {
    position: relative;
    &:hover {
      &:before {
        content: "";
        position: absolute;
        left: 0;
        right: 0;
        top: -9999px;
        bottom: -9999px;
        background-color: rgba(255,255,255,0.2);
        z-index: -1;
      }
    }
  }
}

.formbody{
  position: relative;
    display: -ms-flexbox;
    display: flex;
    -ms-flex-direction: column;
    flex-direction: column;
    min-width: 0;
    word-wrap: break-word;
    background-color: #fff;
    background-clip: border-box;
    border: 1px solid rgba(0,0,0,.125);
    border-radius: .25rem;
    width:360;
}
.headers {
    position: relative;
    display: -ms-flexbox;
    display: flex;
    -ms-flex-direction: column;
    flex-direction: column;
    min-width: 0;
    word-wrap: break-word;
    background-color: #fff;
    background-clip: border-box;
    border: 1px solid rgba(0,0,0,.125);
    border-radius: .25rem;
    width:360;
}
.img{
  width:8em;
  height:8em;
}
</style>